#include <stdio.h>

#include <gsl/gsl_math.h>
#include <gsl/gsl_ieee_utils.h>
#include <fenv.h> 
 
int main(void)  {
    double a=1/3.0, b=sqrt(2)/5, c;

    printf("a:                     Decimal                           Binario\n");
    printf("  %28.20e   ", a);
    gsl_ieee_printf_double(&a);
    printf("\nb:                     Decimal                           Binario\n");
    printf("  %28.20e   ", b);
    gsl_ieee_printf_double(&b);

    printf("\n\nRedondeo hacia abajo:\n");
    fesetround(FE_DOWNWARD); 
    c = a + b;
    printf("a+b:                   Decimal                           Binario\n");
    printf("  %28.20e   ", c);
    gsl_ieee_printf_double(&c);

    printf("\n\nRedondeo hacia arriba:\n");
    fesetround(FE_TONEAREST); 
    c = a + b;
    printf("a+b:                   Decimal                           Binario\n");
    printf("  %28.20e   ", c);
    gsl_ieee_printf_double(&c);


    printf("\n\nRedondeo hacia el mas cercano:\n");
    fesetround(FE_UPWARD); 
    c = a + b;
    printf("a+b:                   Decimal                           Binario\n");
    printf("  %28.20e   ", c);
    gsl_ieee_printf_double(&c);
    printf("\n");

    return 0;
}
// Para compilar
// gcc -o representacionIEEE representacionIEEE.c  -lgsl -lgslcblas -lm

// Para ejecutar
// ./representacionIEEE





